<template>
  <div id="app">
    <TodoHeader></TodoHeader>
    <TodoInput></TodoInput>
    <TodoList></TodoList>
    <TodoFooter></TodoFooter>
    <!-- <TodoInput v-on:addTodoItem="addOneItem"></TodoInput>
    <TodoList
      v-bind:propsdata="todoItems"
      v-on:removeItem="removeOneItem"
      v-on:toggleItem="toggleOneItem"
    ></TodoList>
    <TodoFooter v-on:clearAll="clearAllItems"></TodoFooter> -->    
  </div>
</template>

<script>
import TodoHeader from "./components/TodoHeader.vue";
import TodoInput from "./components/TodoInput.vue";
import TodoList from "./components/TodoList.vue";
import TodoFooter from "./components/TodoFooter.vue";

export default {
  // ES5 코드
  // data() {
  //   return {
  //     todoItems: [],
  //   };
  // },
  /*methods:{ = store의 muatations
     addOneItem(todoItem){
        const obj = {completed: false, item: todoItem};
        localStorage.setItem(todoItem, JSON.stringify(obj));
        this.todoItems.push(obj); // localStorage목록과 화면의 목록을 동기화
     },
     removeOneItem(todoItem, index){       
        localStorage.removeItem(todoItem.item); // remove로 객체를 지워버리면 잘 지워지지 않는다. key값에 접근해서 지워야 함
         this.todoItems.splice(index, 1);
     },
     toggleOneItem(todoItem, index){
      // 안티패턴 : props를 내린것을 받은것을 이벤트버스로 다시 위로 올리는 방식은 좋지 않다. todoItems에 접근해서 동작하도록 하는 것이 훨씬 좋다.
      // todoItem.completed = !todoItem.completed; 
      this.todoItems[index].completed = !this.todoItems[index].completed; // 컴포넌트 간의 경계를 더욱 명확하게 한다.(App.vue의 컨테이너적 성격-비즈니스로직-을 더욱 살린다.)
      localStorage.removeItem(todoItem.item);
      localStorage.setItem(todoItem.item, JSON.stringify(todoItem));
     },
     clearAllItems(){
        localStorage.clear();
        this.todoItems = [];
     }
   },*/
  components: {
    /* 컴포넌트 태그명 == 컴포넌트 내용
    TodoHeader: TodoHeader,
    TodoInput: TodoInput,
    TodoList: TodoList,
    TodoFooter: TodoFooter*/
    // 객체의 속성명과 값이 동일하면 축약할 수 있다.
    TodoHeader,
    TodoInput,
    TodoList,
    TodoFooter,
  },
};
</script>

<style>
body {
  text-align: center;
  background-color: #f6f6f8;
}
input {
  border-style: groove;
  width: 200px;
}
button {
  border-style: groove;
}
.shadow {
  box-shadow: 5px 10px 10px rgba(0, 0, 0, 0.03);
}
</style>
